<template>
  <div
    class="w-full flex gap-2"
    :class="side ? '' : ' self-start'"
  >
    <svn-pro-avatar
      v-if="side && user && !crossed"
      :size="32"
      :type="user?.avatar?.['50'] ? 'photo' : 'monogram'"
      :firstname="user?.firstname"
      :lastname="user?.lastname"
      :image="user?.avatar?.['50']"
    />

    <div class="w-full flex flex-col gap-1">
      <!-- user name -->
      <svn-pro-text
        body-large
        medium
        :class="side ? '' : 'self-end'"
      >
        {{ bubbleTitle }}
      </svn-pro-text>

      <div
        class="flex flex-col gap-2"
        :class="[
          selectedValue ? 'p-4' : '',
          isLastInterviewCompletedAndLocked ? 'bg-surfaceVariant !rounded-lg' : 'bg-surfaceLight',
          side ? 'rounded-tr-lg rounded-bl-lg rounded-br-lg' : 'rounded-tl-lg rounded-bl-lg rounded-br-lg'
        ]"
      >
        <v-rating
          v-if="questionType === InterviewAppQuestionTypes.rating"
          :disabled="true"
          :length="ratingLength"
          :model-value="selectedValue"
          empty-icon="custom:mingcute:star-line"
          full-icon="custom:mingcute:star-fill"
          color="onSurface"
          size="small"
          active-color="onSurface"
        />

        <svn-pro-info-tag
          v-else-if="questionType !== InterviewAppQuestionTypes.rating && questionType !== InterviewAppQuestionTypes.open"
          :tag-type="crossed ? 'primary' : 'info'"
          :text="selectedValue"
          tag-style="outlined"
          class="w-fit h-fit"
          :class="[side ? '' : 'self-end']"
        />

        <!-- Comments input -->
        <div
          v-if="comment"
          class="text-onSurface text-body-2 break-words w-full"
          :class="side ? '' : 'text-end'"
          v-html="comment"
        />
      </div>
    </div>

    <svn-pro-avatar
      v-if="!side && user && !crossed"
      :size="32"
      :type="user?.avatar?.['50'] ? 'photo' : 'monogram'"
      :firstname="user?.firstname"
      :lastname="user?.lastname"
      :image="user?.avatar?.['50']"
    />
  </div>
</template>

<script setup>
import { ref, watch, onMounted } from "vue";
import SvnProText from '../styles/SvnProText.vue';
import SvnProAvatar from '../avatar/SvnProAvatar.vue';
import SvnProInfoTag from '../chip/SvnProInfoTag.vue';
import { InterviewAppQuestionTypes } from '../../constants/types';

const props = defineProps({
  side: { type: Boolean, default: true },
  comment: { type: String, default: "" },
  user: { type: Object, default: () => {} },
  crossed: { type: Boolean, default: false },
  selectedValue: { type: String, default: "" },
  ratingLength: { type: String, default: "5" },
  bubbleTitle: { type: String, default: "" },
  isLastInterviewCompletedAndLocked: { type: Boolean, default: false },
  questionType: { type: String, default: "InterviewApp::Questions::Open" },
});

const commentsRef = ref(null);

onMounted(() => {
  useCommentForAnswers();
});

const useCommentForAnswers = () => {
  commentsRef.value = props?.comment
}

watch(props, (newValue, oldValue) => {
  if (newValue) {
    useCommentForAnswers();
  }
});
</script>

<style scoped>
:deep(.ql-toolbar) {
  display: none !important;
}

:deep(.ql-container) {
  cursor: default !important;
  border: 0px none !important;
}

:deep(.ql-editor) {
  padding: 0px !important;
}

:deep(.input .ql-editor p) {
  text-align: end !important;
}
</style>